# # sample index page with internationalization (T)
def index():
    redirect(URL(r=request,f='listes',args=['all']))
    return dict()
    
def aide():
    return dict(message="ici une page d'aide...")
        

@auth.requires_login()
def vote():
    bulletin=''.join(session.v)
    old_vote=(db.Votes.U_id==auth.user.id)&(db.Votes.Q_id==request.args[0])
    
    #si ancien vote existant
    if len(db(old_vote).select())>0:
        for v in db(old_vote).select():          
            old_bulletin=v.Buletin                                          
            old_matchs=matching(request.args[0],old_bulletin,v.date_vote)
            
        db(old_vote).update(D_id='',
                            Buletin=bulletin,
                            date_vote=request.now)
                            
        matchs=matching(request.args[0],bulletin,request.now)
        update_resultat(request.args[0],matchs,old_matchs)
        #session.flash="vote mis à jour...de %s  vers %s soit %s vers %s" %(old_bulletin,bulletin,old_matchs,matchs)
    #si pas d'ancien vote    
    else:
        vote_id=db.Votes.insert(Q_id=request.args[0],
                                U_id=auth.user.id,D_id='',
                                Buletin=bulletin,
                                date_vote=request.now)
        la_Q=db(db.Questions.id==request.args[0]).select()[0] 
        matchs=matching(request.args[0],bulletin,request.now)                       
        db(db.Questions.id==request.args[0]).update(nbr_votes=la_Q.nbr_votes+1)
        update_resultat(request.args[0],matchs)
        
        #session.flash="vote enregistré...%s" %matchs
    redirect(URL(r=request,f="listes"))
    return dict()
    
def str_to_dict(chaine):
    dico={}
    if chaine==None or chaine=='{}':
        return dico
    chaine=chaine.replace(' ','')
    chaine=chaine.replace('{','')
    chaine=chaine.replace('}','')
    chaine=chaine.replace("'",'')
    liste=chaine.split(',')
    for elem in liste:
        l_e=elem.split(':')
        dico[l_e[0]]=int(l_e[1])
    return dico
    
def update_resultat(Q_id,matchs,old_matchs=[]):
    resultat={}
    la_Q=db(db.Questions.id==Q_id).select()[0]
    resultat=str_to_dict(la_Q.resultat)
    old_resultat=resultat.copy()
    #on décrémente les anciens matchs
    for m in old_matchs:
        resultat[m]=resultat[m]-1
    #on incrémente les nouveaux matchs    
    for m in matchs:
        try:
            resultat[m]+=1
        except:
            resultat[m]=1
        
    db(db.Questions.id==Q_id).update(resultat=resultat)
    session.flash="matchs... %s vers %s  ** resultat...%s  vers %s" %(old_matchs,matchs,old_resultat,resultat)
    
def matching(Q_id,bulletin,date_vote):
    matchs=[]
    liste_rns=[]
    #liste des réponses sélectionnées
    liste=bulletin.split('_')[1:]
    
    #liste des réponses non sélectionnées
    #prise en compte de la date pour les mises à jour (pour ne pas annuler un match sur question inexistante au temps du vote...)
    for j in  db(db.Reponses.Q_id==Q_id).select(db.Reponses.ALL):
        if str(j.id) not in liste and j.date_postee<=date_vote:
            liste_rns.append(str(j.id))
        
    liste_b=liste+liste_rns
    for r in liste:
        for r2 in liste_b[liste_b.index(r)+1:]:
            couple=r+'>'+r2
            matchs.append(couple)
    return matchs
    
@auth.requires_login()    
def new_Q():
    form=SQLFORM(db.Questions)
    if form.accepts(request.vars,session):
        session.flash="Nouvelle Question prise en compte.."
        redirect(URL(r=request,f="listes"))
    return dict(form=form)
    
@auth.requires_login()
def new_R():
    db.Reponses.Q_id.default=request.args[0]
    form=SQLFORM(db.Reponses)
    if form.accepts(request.vars,session):
        session.flash="Nouvelle Réponse prise en compte.."
        redirect(URL(r=request,f="listes"))
    return dict(form=form)
    
@auth.requires_login()  #membership('Administrateurs')
def new_T():
    form=SQLFORM(db.Tags,fields=['titre'])
    if form.accepts(request.vars,session):
        session.flash="Nouveau Tag pris en compte..."
        redirect(URL(r=request,f="listes"))
    return dict(form=form)

@auth.requires_login()
def add_T():
    message=''
    existe=0
    db.Tags_Questions.Q_id.default=request.args[0]
    form=SQLFORM(db.Tags_Questions)
    if form.accepts(request.vars,session):
        for Tnum in db(db.Tags_Questions.Q_id==request.args[0]).select(db.Tags_Questions.ALL):
            if str(Tnum.T_id)==form.vars.T_id:
                existe+=1
                if existe>1:
                    db(db.Tags_Questions.id==form.vars.id).delete()
                    message="existait déjà"
        session.flash="Nouveau Tag pris en compte...%s" %message
        redirect(URL(r=request,f="listes"))
    return dict(form=form)
    
def listes():
    if request.args:
        session.tag=request.args[0]
         
    if session.tag=='all':        
        questions=db().select(db.Questions.ALL)
    else:
        questions=db((db.Tags_Questions.T_id==session.tag)&(db.Tags_Questions.Q_id==db.Questions.id)).select(db.Questions.ALL)
        #session.flash="Tag actif...%s  Questions %s" %(tag_actif,questions)
        #questions=db().select(db.Questions.ALL)
        
    return dict(questions=questions)

def data():
    if not session.m:session.m=[]
    if not session.v:session.v=[]
    for clef in request.vars:
        if 'champ' in clef:
            q=clef[5:clef.find('_')]
            if not session.q or session.q!=q:
                session.m=[]
                session.v=[]
                session.q=q
            r=clef[clef.find('_'):]
            if request.vars[clef] in session.m:
                idx=session.m.index(request.vars[clef])
                del(session.m[idx])
                del(session.v[idx])
            session.m.append(request.vars[clef])
            session.v.append(r)
    return TABLE(*[TR(v) for v in session.m]).xml()

def clear_target():
    session.m=[]
    session.v=[]
    return TABLE(*[TR(v) for v in session.m]).xml()
           
        
# # uncomment the following if you have defined "auth" and "crud" in models
def user(): return dict(form=auth())
# def data(): return dict(form=crud())
# def download(): return response.download(request,db)
# # tip: use @auth.requires_login, requires_membership, requires_permission